unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, Grids, U_Graph;

type

  TForm1 = class(TForm)
    M_Knoten: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    M_Kanten: TMemo;
    MainMenu1: TMainMenu;
    MI_Datei: TMenuItem;
    MI_Beenden: TMenuItem;
    MI_Eulerkreis: TMenuItem;
    MI_ExistenzEulerkreis: TMenuItem;
    MI_FindeEulerkreis: TMenuItem;
    MI_Traversierung: TMenuItem;
    MI_Tiefensuche: TMenuItem;
    MI_Breitensuche_mit_Queue: TMenuItem;
    MI_Darstellung: TMenuItem;
    MI_Adjazenzmatrix: TMenuItem;
    MI_Adjanzenzliste: TMenuItem;
    SG_Matrix: TStringGrid;
    MI_Rundreise: TMenuItem;
    MI_Hamilton: TMenuItem;
    MI_Oeffnen: TMenuItem;
    MI_Speichern: TMenuItem;
    N1: TMenuItem;
    OD: TOpenDialog;
    SD: TSaveDialog;
    MI_Tiefensuche_mit_Stack: TMenuItem;
    MI_TSP: TMenuItem;
    MI_KurzeWege: TMenuItem;
    MI_Dijkstra: TMenuItem;
    procedure MI_ExistenzEulerkreisClick(Sender: TObject);
    procedure MI_FindeEulerkreisClick(Sender: TObject);
    procedure MI_AdjazenzmatrixClick(Sender: TObject);
    procedure MI_TiefensucheClick(Sender: TObject);
    procedure MI_HamiltonClick(Sender: TObject);
    procedure MI_SpeichernClick(Sender: TObject);
    procedure MI_OeffnenClick(Sender: TObject);
    procedure MI_Tiefensuche_mit_StackClick(Sender: TObject);
    procedure MI_Breitensuche_mit_QueueClick(Sender: TObject);
    procedure MI_TSPClick(Sender: TObject);
    procedure MI_DijkstraClick(Sender: TObject);
    procedure MI_AdjanzenzlisteClick(Sender: TObject);
  private
    { Private declarations }
    function GetGraphFromForm: TGraph;
    procedure GetFormFromGraph(Graph: TGraph);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.GetFormFromGraph(Graph: TGraph);
var i: integer;
begin
  M_Kanten.Lines.Clear;
  M_Knoten.Lines.Clear;
  for i:= 1 to Graph.Knotenanzahl
  do M_Knoten.Lines.Add(Graph.Knoten[i]);
  for i:= 1 to Graph.Kantenanzahl
  do M_Kanten.Lines.Add(Graph.Kanten[i].Start+Graph.Kanten[i].Ziel+','+IntToStr(Graph.Kanten[i].Gewicht));
end;

function TForm1.GetGraphFromForm: TGraph;
var i: integer;
    Graph: TGraph;
begin
  Graph:= TGraph.create;
  Graph.Knotenanzahl:= M_Knoten.Lines.Count;
  Graph.Kantenanzahl:= M_Kanten.Lines.Count;
  for i:= 1 to Graph.Knotenanzahl
  do begin
       Graph.Knoten[i]:= M_Knoten.Lines[i-1][1];
     end;
  for i:= 1 to Graph.Kantenanzahl
  do begin
       Graph.Kanten[i].Start:= M_Kanten.Lines[i-1][1];
       Graph.Kanten[i].Ziel:= M_Kanten.Lines[i-1][2];
       Graph.Kanten[i].Gewicht:= StrToInt(copy(M_Kanten.Lines[i-1],4,10));
     end;
  result:= Graph;
end;

procedure TForm1.MI_ExistenzEulerkreisClick(Sender: TObject);
var Graph: TGraph;
begin
  Graph:= GetGraphFromForm;
  if Graph.PruefeEulerkreis = true
  then ShowMessage('Ja, es gibt einen Eulerkreis!')
  else ShowMessage('Nein, es gibt keinen Eulerkreis!');
  Graph.Free;
end;

procedure TForm1.MI_FindeEulerkreisClick(Sender: TObject);
var i: integer;
    Weg: TWeg;
    Ausgabe: String;
    Graph: TGraph;
begin
  Graph:= GetGraphFromForm;

  Weg:= Graph.SucheEulerkreis;

  Ausgabe:= '';
  for i:= 1 to Weg.Anzahl
  do Ausgabe:= Ausgabe+Weg.Kanten[i].Start+Weg.Kanten[i].Ziel+'-';
  ShowMessage(Ausgabe);
  Graph.free;
end;

procedure TForm1.MI_AdjazenzmatrixClick(Sender: TObject);
var Graph: TGraph;
    Matrix: TAdjazenzmatrix;
    x,y: integer;
begin
  Graph:= GetGraphFromForm;
  Matrix:= Graph.Adjazenzmatrix;
  for x:= 1 to MAXKNOTEN
  do begin
       SG_Matrix.Cells[x,0]:= Graph.Knoten[x];
       SG_Matrix.Cells[0,x]:= Graph.Knoten[x];
       for y:= 1 to MAXKNOTEN
       do if (x>Graph.Knotenanzahl) or (y>Graph.Knotenanzahl)
          then SG_Matrix.Cells[x,y]:= ''
          else if Matrix[x,y]=MAXENTFERNUNG
               then SG_Matrix.Cells[x,y]:= '---'
               else SG_Matrix.Cells[x,y]:= IntToStr(Matrix[x,y]);
     end;
  Graph.free;
end;

procedure TForm1.MI_TiefensucheClick(Sender: TObject);
var Graph: TGraph;
    Kanten: TWeg;
    Ausgabe: String;
    i: integer;
begin
  Graph:= GetGraphFromForm;
  Kanten:= Graph.Tiefensuche;
  Ausgabe:= '';
  for i:= 1 to Kanten.Anzahl
  do Ausgabe:= Ausgabe+Kanten.Kanten[i].Start+Kanten.Kanten[i].Ziel+', ';
  ShowMessage(Ausgabe);
  Graph.free;
end;

procedure TForm1.MI_HamiltonClick(Sender: TObject);
var Graph: TGraph;
    Kanten: TWeg;
    Ausgabe: String;
    i: integer;
begin
  Graph:= GetGraphFromForm;
  Kanten:= Graph.Hamilton;
  if Kanten.Anzahl=0
  then Ausgabe:= 'Es gibt keinen Hamiltonkreis'
  else begin
          Ausgabe:= '';
          for i:= 1 to Kanten.Anzahl
          do Ausgabe:= Ausgabe+Kanten.Kanten[i].Start+Kanten.Kanten[i].Ziel+'-';
       end;   
  ShowMessage(Ausgabe);
  Graph.free;
end;

procedure TForm1.MI_SpeichernClick(Sender: TObject);
var Graph: TGraph;
begin
  if SD.Execute
  then begin
         Graph:= GetGraphFromForm;
         Graph.Speichern(SD.FileName);
         Graph.free;
       end;
end;

procedure TForm1.MI_OeffnenClick(Sender: TObject);
var Graph: TGraph;
begin
  if OD.Execute
  then begin
         Graph:= TGraph.create;
         Graph.Oeffnen(OD.FileName);
         GetFormFromGraph(Graph);
         Graph.Free;
       end;
end;

procedure TForm1.MI_Tiefensuche_mit_StackClick(Sender: TObject);
var Graph: TGraph;
    Kanten: TWeg;
    Ausgabe: String;
    i: integer;
begin
  Graph:= GetGraphFromForm;
  Kanten:= Graph.Tiefensuche_iterativ;
  Ausgabe:= '';
  for i:= 1 to Kanten.Anzahl
  do Ausgabe:= Ausgabe+Kanten.Kanten[i].Start+Kanten.Kanten[i].Ziel+', ';
  ShowMessage(Ausgabe);
  Graph.free;
end;

procedure TForm1.MI_Breitensuche_mit_QueueClick(Sender: TObject);
var Graph: TGraph;
    Kanten: TWeg;
    Ausgabe: String;
    i: integer;
begin
  Graph:= GetGraphFromForm;
  Kanten:= Graph.Breitensuche_iterativ;
  Ausgabe:= '';
  for i:= 1 to Kanten.Anzahl
  do Ausgabe:= Ausgabe+Kanten.Kanten[i].Start+Kanten.Kanten[i].Ziel+', ';
  ShowMessage(Ausgabe);
  Graph.free;
end;

procedure TForm1.MI_TSPClick(Sender: TObject);
var Graph: TGraph;
    Kanten: TWeg;
    Ausgabe: String;
    i: integer;
begin
  Graph:= GetGraphFromForm;
  Kanten:= Graph.TSP;
  if Kanten.Anzahl=0
  then Ausgabe:= 'Es gibt keine Rundreise'
  else begin
          Ausgabe:= '';
          for i:= 1 to Kanten.Anzahl
          do Ausgabe:= Ausgabe+Kanten.Kanten[i].Start+Kanten.Kanten[i].Ziel+'-';
       end;
  ShowMessage(Ausgabe);
  Graph.free;
end;

procedure TForm1.MI_DijkstraClick(Sender: TObject);
var Graph: TGraph;
    Kanten: TWeg;
    Ausgabe: String;
    i: integer;
    Startknoten: integer;
begin
  Graph:= GetGraphFromForm;
  Startknoten:= StrToInt(inputbox('Startknoten','Von wo starten?','1'));
  Kanten:= Graph.Dijkstra(Startknoten);
  Ausgabe:= '';
  for i:= 1 to Kanten.Anzahl
  do Ausgabe:= Ausgabe+Kanten.Kanten[i].Start+Kanten.Kanten[i].Ziel+'-';
  ShowMessage(Ausgabe);
  Graph.free;
end;

procedure TForm1.MI_AdjanzenzlisteClick(Sender: TObject);
var Graph: TGraph;
    Liste: TAdjazenzliste;
    x,y: integer;
begin
  for x:= 0 to MAXKNOTEN
  do for y:= 0 to MAXKNOTEN
     do SG_Matrix.Cells[x,y]:= '';
  Graph:= GetGraphFromForm;
  Liste:= Graph.Adjazenzliste;
  for x:= 1 to Graph.Knotenanzahl
  do begin
       SG_Matrix.Cells[x,0]:= Graph.Knoten[x];
       if not Liste[x].Leer
       then begin
              Liste[x].anAnfang;
              y:= 0;
              while not(Liste[x].amEnde)
              do begin
                   inc(y);
                   SG_Matrix.Cells[x,y]:= Graph.Knoten[(Liste[x].Aktuell as TListenElement).Knotennummer]+
                                          IntToStr((Liste[x].Aktuell as TListenElement).Distanz);
                   Liste[x].vor;
                 end;
              inc(y);
              SG_Matrix.Cells[x,y]:= Graph.Knoten[(Liste[x].Aktuell as TListenElement).Knotennummer]+
                                          IntToStr((Liste[x].Aktuell as TListenElement).Distanz);
            end;
     end;
  for x:= 1 to Graph.Knotenanzahl
  do Liste[x].free;
  Graph.free;
end;

end.
